#define encode_string
argument0 = string_replace_all(argument0, "%", "%25");
argument0 = string_replace_all(argument0, "$", "%24");
argument0 = string_replace_all(argument0, "&", "%26");
argument0 = string_replace_all(argument0, "+", "%2B");
argument0 = string_replace_all(argument0, ",", "%2C");
argument0 = string_replace_all(argument0, "/", "%2F");
argument0 = string_replace_all(argument0, ":", "%3A");
argument0 = string_replace_all(argument0, ";", "%3B");
argument0 = string_replace_all(argument0, "=", "%3D");
argument0 = string_replace_all(argument0, "?", "%3F");
argument0 = string_replace_all(argument0, "@", "%40");
argument0 = string_replace_all(argument0, " ", "%20");
argument0 = string_replace_all(argument0, '"', "%22");
argument0 = string_replace_all(argument0, "<", "%3C");
argument0 = string_replace_all(argument0, ">", "%3E");
argument0 = string_replace_all(argument0, "#", "%23");
argument0 = string_replace_all(argument0, "{", "%7B");
argument0 = string_replace_all(argument0, "}", "%7D");
argument0 = string_replace_all(argument0, "|", "%7C");
argument0 = string_replace_all(argument0, "\", "%5C");
argument0 = string_replace_all(argument0, "^", "%5E");
argument0 = string_replace_all(argument0, "~", "%7E");
argument0 = string_replace_all(argument0, "[", "%5B");
argument0 = string_replace_all(argument0, "]", "%5D");
argument0 = string_replace_all(argument0, "`", "%60");
argument0 = string_replace_all(argument0, "chr(13)", "%13");
argument0 = string_replace_all(argument0, "chr(10)", "%10");
argument0 = string_replace_all(argument0, "chr(09)", "%09");
#define md5
/**
 * Provides MD5 message digest of given string
 * This is the main md5 function. Since you only mostly want to use this,
 * it's easy to call just md5(). This function turns the given string into
 * hashable words, then produces the digest and finally returns the result
 * in hexadecimal format (which is used in most places). Note that due to
 * GM array size limitations, no longer than 3999936 character string can
 * be hashed.
 *
 * string md5 (string)
 * argument0 : The string given to this method to hash.
 * return    : Returns the hash as a string in hex format.
 *
 * Copyright 2005  Ville Kalliomki (Rithiur)
 * Based on Javascript implementation Copyright  Paul Johnston 1999 - 2002 
 * (http://pajhome.org.uk/crypt/md5/md5src.html)
 */ 
{
    md5_fromstring(argument0);
    md5_hash();
    return md5_tohex();
}

#define md5_add
/**
 * Sum 2 words bitwise
 * This function is to pretty much make sure that the addition is kept
 * within 32 bits.
 *
 * Copyright 2005  Ville Kalliomki (Rithiur)
 */
{
    // GM6 has problems with big real values, so let's do following in
    // Manually: 
    // return argument0 + argument1 & 4294967295; 
       
    var old;
            
    while (argument1 != 0)
    {
        old = argument1 & 4294967295;
        argument1 = (argument0 & argument1) << 1;
        argument0 = argument0 ^ old;
    }
    
    return argument0;      
}

#define md5_cmd
/**
 * Performs common hashing command.
 * Copyright 2005  Ville Kalliomki (Rithiur)
 */
{
    return md5_add(md5_roll(md5_add(md5_add(argument1, argument0), md5_add(argument3, argument5)), argument4), argument2);
}

#define md5_F
/**
 * Function F as defined in md5
 * Copyright 2005  Ville Kalliomki (Rithiur)
 */
{
    return md5_cmd((argument1 & argument2) | ((~argument1) & argument3), argument0, argument1, argument4, argument5, argument6);
}

#define md5_file
/**
 * Produces md5 fingerprint from given file
 * Sometimes you might want to get the md5 fingerprint of files. This function
 * makes it easier since you only need to provide the filename and the hash
 * is produced for you. Due to the array limitations of Game Maker, the file
 * size is limited to 3.81mb (or 3999936 bytes). However, it is advisable to
 * only use this function for very small files, since this is not very fast
 * function, and a dll for this purpose could be much more optimal.
 * Copyright 2005  Ville Kalliomki (Rithiur)
 */
{
    md5_fromfile(argument0);
    md5_hash();
    return md5_tohex();
}

#define md5_fromfile
/**
 * Produces the bit words out of given file.
 * This reads the binary data of the file and produces a hash based on it.
 * There is absolutely no need to for file to be text only. The file is
 * handled as binary file, no matter what it contains. Note that due to GM's
 * limitations in file handling, it's also impossible to handle the files as
 * text files.
 * Copyright 2005  Ville Kalliomki (Rithiur)
 */
{
    var fp, i;
    
    fp = file_bin_open(argument0, 0);
    md5_length = file_bin_size(fp) * 8;
    
    // Need to initialize this array, because GM is stupid
    for (i = 0; i < md5_length; i += 32)
    {
        md5_set(i, 0);
    }
    
    // Read data from the file.    
    for (i = 0; i < md5_length; i += 8)
    {
        md5_set(i, md5_get(i) | file_bin_read_byte(fp) << i mod 32);
    }
    
    file_bin_close(fp);
}
#define md5_fromstring
/**
 * Produces the bit words out of single string.
 * Copyright 2005  Ville Kalliomki (Rithiur)
 */
{
    var i;
    
    md5_length = string_length(argument0) * 8;
    
    // Need to initialize this array, because GM is stupid
    for (i = 0; i < md5_length; i += 32)
    {
        md5_set(i, 0);
    }
    
    // Let's put the string into words
    for (i = 0; i < md5_length; i += 8)
    {
        md5_set(
            i, 
            md5_get(i) | ord(
                string_char_at(argument0, i / 8 + 1)
            ) << i mod 32
        );
    }
}
#define md5_G
/**
 * Function G as defined in md5
 * Copyright 2005  Ville Kalliomki (Rithiur)
 */
{
    return md5_cmd((argument1 & argument3) | (argument2 & (~argument3)), argument0, argument1, argument4, argument5, argument6);
}

#define md5_get
/**
 * Returns the value of a word at given bit position.
 * Copyright 2005  Ville Kalliomki (Rithiur)
 */
{
    return md5_words[(argument0 >> 5) div 32000, (argument0 >> 5) mod 32000];
}
#define md5_H
/**
 * Function D as defined in md5
 * Copyright 2005  Ville Kalliomki (Rithiur)
 */
{
    return md5_cmd(argument1 ^ argument2 ^ argument3, argument0, argument1, argument4, argument5, argument6);
}

#define md5_hash
/**
 * Produces the md5 hash from the words.
 * All the words are saved into local variable md5_words. This function
 * uses those words to produce the md5 digest. This method is separate, so
 * that md5 output is not necessarily restricted to just hashing one kinds
 * strings, but you can use normal bits too if you want (and know how).
 *
 * Copyright 2005  Ville Kalliomki (Rithiur)
 */
{
    var bits, i, A, B, C, D, AA, BB, CC, DD;
    
    bits = md5_length;

    // Pad number 1 to the words
    if (bits mod 32 == 0)
    {  
        md5_set(bits, 128);
        bits += 32;
    }
    else
    { 
        md5_set(bits, md5_get(bits) | 128 << bits mod 32);
        bits += 32 - bits mod 32;
    }
    
    // Pad all the 0 bits to the words until length is appropriate
    while (bits mod 512 != 448)
    {
        md5_set(bits, 0);
        bits += 32;
    }
    
    // Add length (note: string length limited to less than 2^32)
    md5_set(bits, md5_length);
    md5_set(bits + 32, 0);
    
    // Initialize the values
    A = 1732584193;
    B = 4023233417;
    C = 2562383102;
    D =  271733878;
    
    count = (bits + 64) / 32
           
    // And, so we loop
    for (i = 0; i < count; i += 16)
    {
        AA = A;
        BB = B;
        CC = C;
        DD = D;
        
        A = md5_F(A, B, C, D, md5_word(i +  0), 7 , -680876936 );
        D = md5_F(D, A, B, C, md5_word(i +  1), 12, -389564586 );
        C = md5_F(C, D, A, B, md5_word(i +  2), 17,  606105819 );
        B = md5_F(B, C, D, A, md5_word(i +  3), 22, -1044525330);
        A = md5_F(A, B, C, D, md5_word(i +  4), 7 , -176418897 );
        D = md5_F(D, A, B, C, md5_word(i +  5), 12,  1200080426);
        C = md5_F(C, D, A, B, md5_word(i +  6), 17, -1473231341);
        B = md5_F(B, C, D, A, md5_word(i +  7), 22, -45705983  );
        A = md5_F(A, B, C, D, md5_word(i +  8), 7 ,  1770035416);
        D = md5_F(D, A, B, C, md5_word(i +  9), 12, -1958414417);
        C = md5_F(C, D, A, B, md5_word(i + 10), 17, -42063     );
        B = md5_F(B, C, D, A, md5_word(i + 11), 22, -1990404162);
        A = md5_F(A, B, C, D, md5_word(i + 12), 7 ,  1804603682);
        D = md5_F(D, A, B, C, md5_word(i + 13), 12, -40341101  );
        C = md5_F(C, D, A, B, md5_word(i + 14), 17, -1502002290);
        B = md5_F(B, C, D, A, md5_word(i + 15), 22,  1236535329);
        
        A = md5_G(A, B, C, D, md5_word(i +  1), 5 , -165796510 );
        D = md5_G(D, A, B, C, md5_word(i +  6), 9 , -1069501632);
        C = md5_G(C, D, A, B, md5_word(i + 11), 14,  643717713 );
        B = md5_G(B, C, D, A, md5_word(i +  0), 20, -373897302 );
        A = md5_G(A, B, C, D, md5_word(i +  5), 5 , -701558691 );
        D = md5_G(D, A, B, C, md5_word(i + 10), 9 ,  38016083  );
        C = md5_G(C, D, A, B, md5_word(i + 15), 14, -660478335 );
        B = md5_G(B, C, D, A, md5_word(i +  4), 20, -405537848 );
        A = md5_G(A, B, C, D, md5_word(i +  9), 5 ,  568446438 );
        D = md5_G(D, A, B, C, md5_word(i + 14), 9 , -1019803690);
        C = md5_G(C, D, A, B, md5_word(i +  3), 14, -187363961 );
        B = md5_G(B, C, D, A, md5_word(i +  8), 20,  1163531501);
        A = md5_G(A, B, C, D, md5_word(i + 13), 5 , -1444681467);
        D = md5_G(D, A, B, C, md5_word(i +  2), 9 , -51403784  );
        C = md5_G(C, D, A, B, md5_word(i +  7), 14,  1735328473);
        B = md5_G(B, C, D, A, md5_word(i + 12), 20, -1926607734);
        
        A = md5_H(A, B, C, D, md5_word(i +  5), 4 , -378558    );
        D = md5_H(D, A, B, C, md5_word(i +  8), 11, -2022574463);  
        C = md5_H(C, D, A, B, md5_word(i + 11), 16,  1839030562);
        B = md5_H(B, C, D, A, md5_word(i + 14), 23, -35309556  );
        A = md5_H(A, B, C, D, md5_word(i +  1), 4 , -1530992060);   
        D = md5_H(D, A, B, C, md5_word(i +  4), 11,  1272893353);
        C = md5_H(C, D, A, B, md5_word(i +  7), 16, -155497632 );
        B = md5_H(B, C, D, A, md5_word(i + 10), 23, -1094730640);
        A = md5_H(A, B, C, D, md5_word(i + 13), 4 ,  681279174 );
        D = md5_H(D, A, B, C, md5_word(i +  0), 11, -358537222 );
        C = md5_H(C, D, A, B, md5_word(i +  3), 16, -722521979 );
        B = md5_H(B, C, D, A, md5_word(i +  6), 23,  76029189  );
        A = md5_H(A, B, C, D, md5_word(i +  9), 4 , -640364487 );
        D = md5_H(D, A, B, C, md5_word(i + 12), 11, -421815835 );
        C = md5_H(C, D, A, B, md5_word(i + 15), 16,  530742520 );
        B = md5_H(B, C, D, A, md5_word(i +  2), 23, -995338651 );
        
        A = md5_I(A, B, C, D, md5_word(i +  0), 6 , -198630844 );
        D = md5_I(D, A, B, C, md5_word(i +  7), 10,  1126891415);
        C = md5_I(C, D, A, B, md5_word(i + 14), 15, -1416354905);
        B = md5_I(B, C, D, A, md5_word(i +  5), 21, -57434055  );
        A = md5_I(A, B, C, D, md5_word(i + 12), 6 ,  1700485571);
        D = md5_I(D, A, B, C, md5_word(i +  3), 10, -1894986606);
        C = md5_I(C, D, A, B, md5_word(i + 10), 15, -1051523   );
        B = md5_I(B, C, D, A, md5_word(i +  1), 21, -2054922799);
        A = md5_I(A, B, C, D, md5_word(i +  8), 6 ,  1873313359);
        D = md5_I(D, A, B, C, md5_word(i + 15), 10, -30611744  );
        C = md5_I(C, D, A, B, md5_word(i +  6), 15, -1560198380);
        B = md5_I(B, C, D, A, md5_word(i + 13), 21,  1309151649);
        A = md5_I(A, B, C, D, md5_word(i +  4), 6 , -145523070 );
        D = md5_I(D, A, B, C, md5_word(i + 11), 10, -1120210379);
        C = md5_I(C, D, A, B, md5_word(i +  2), 15,  718787259 );
        B = md5_I(B, C, D, A, md5_word(i +  9), 21, -343485551 );
        
        A = md5_add(A, AA);
        B = md5_add(B, BB);
        C = md5_add(C, CC);
        D = md5_add(D, DD);
    }
    
    // Save the results into the results array 
    md5_result[0] = A;
    md5_result[1] = B;
    md5_result[2] = C;
    md5_result[3] = D;
}
#define md5_I
/**
 * Function I as defined in md5
 * Copyright 2005  Ville Kalliomki (Rithiur)
 */
{
    return md5_cmd(argument2 ^ (argument1 | (~argument3)), argument0, argument1, argument4, argument5, argument6);
}

#define md5_roll
/**
 * Rolls (rotates) the given word to left by given amount.
 * Copyright 2005  Ville Kalliomki (Rithiur)
 */
{
    return ((argument0 << argument1 & 4294967295) | (argument0 >> (32 - argument1)));
}

#define md5_set
/**
 * Sets the value of a word at given bit position.
 * Copyright 2005  Ville Kalliomki (Rithiur)
 */
{
    md5_words[
        (argument0 >> 5) div 32000,
        (argument0 >> 5) mod 32000
    ] = argument1;
}
#define md5_tohex
/**
 * Returns hexadecimal representation of the result
 * Copyright 2005  Ville Kalliomki (Rithiur)
 */
{
    var retval, bas16, i;
    
    retval = "";
    base16 = "0123456789abcdef";
    
    // Now, let's put the digest into hex form (which is used most often)
    for (i = 0; i < 4 * 32; i += 8)
    {
        retval += 
            string_char_at(
                base16,
                1 + ((md5_result[i >> 5] >> (i mod 32 + 4)) & 15)
            ) +
            string_char_at(
                base16,
                1 + ((md5_result[i >> 5] >> (i mod 32)) & 15)
            );
    }
    
    return retval;
}
#define md5_word
/**
 * Returns the nth word.
 * Copyright 2005  Ville Kalliomki (Rithiur)
 */
{
    return md5_words[argument0 div 32000, argument0 mod 32000];
}
#define GJ_init
/*
** RUN THIS FILE SOMEWHERE AT GAME LAUNCH. IT'S VERY IMPORTANT. SO DO IT.
*/

globalvar _GJ_GAME_ID, _GJ_PRIVATE_KEY, _GJ_SHOW_ERRORS, netread_dll;

netread_dll = external_define("NetRead.dll", "NetRead", 1, 1, 2, 1, 1);

// Set the following two variables to those found in your game online.
_GJ_GAME_ID = 8710; _GJ_PRIVATE_KEY = "0328394653c523d5d222f525ef68a166";

// When the following is true, a GM error message will let you know
// what's wrong. Useful for debugging.
_GJ_SHOW_ERRORS = true;

#define GJ_fill_map
ds_map_clear(argument0);
var p, cur, str, state; str = ""; state = 0;
for (p=17; p<string_length(argument1); p+=1) {
    cur = string_char_at(argument1, p);
    switch (true) {
        case (cur == chr(58)) && (state == 0):
            key = str; str = ""; p+= 1; state = 1;
        break;
        case (cur == chr(13)):
            ds_map_add(argument0, key, string_copy(str, 1, string_length(str) - 1)); str = ""; state = 0; p+= 1;
        break;
        default:
            str+= cur;
        break;
    }
}

#define GJ_fill_map_ext
var p, cur, map, str, state, first; str = ""; state = 0; first = "";
for (p=17; p<string_length(argument1); p+=1) {
    cur = string_char_at(argument1, p);
    switch (true) {
        case (cur == chr(58)) && (state < 2):
            if (state == 0) first = str;
            if (first == str) {
                map = ds_map_create(); ds_list_add(argument0, map);
            }
            key = str; str = ""; p+= 1; state = 2;
        break;
        case (cur == chr(13)):
            ds_map_add(map, key, string_copy(str, 1, string_length(str) - 1)); str = ""; state = 1; p+= 1;
        break;
        default:
            str+= cur;
        break;
    }
}

#define netread
/*
**  Usage:
**      str = netread(document, bytes);
**
**  Author:
**      Roach
**
**  Arguments:
**      document    online document to read (ex: "http://google.com/"), string
**      bytes       number of bytes to read, real
**
**  Returns:
**      str         the source of the document
*/
{
    return external_call(netread_dll, argument0, string(argument1));
}

#define url_signature
//Parameters
//---------------------------------------------------------------//
//argument0 - URL
//argument1 - Private Key
//---------------------------------------------------------------//

var pre, url, add, signature;
pre = "http://gamejolt.com/api/game/v1/";
if (argument1 == true)
    add = "?game_id="+ string(_GJ_GAME_ID);
else
    add = "&game_id="+ string(_GJ_GAME_ID);

url = pre + string(argument0) + add;

signature = md5(url + string(_GJ_PRIVATE_KEY));
return pre + string(argument0) + add +"&signature="+ signature;

#define GJ_auto_login
/*
**  Usage:
**      GJ_auto_login(map);
**
**  Arguments:
**      map             ds_map to save data to, data structure id
**
**  Returns:
**      success         boolean
**
**  Notes:
**      Run this script at game launch if your game can be run via "Quick Play" to
**      automatically log the playing user in.
**      If successful, the given map will be filled in with the player's details.
*/
{
    if (parameter_count() <= 1)
        return false;
    
    var a, para, u, t, r; r = 0;
    
    for (a=1; a<=parameter_count(); a+=1) {
        para = parameter_string(a);
        if (r mod 2 == 0) if (string_pos("gjapi_username", para) == 1) {
            u = string_copy(para, 16, string_length(para) - 15); r+= 1;
        }
        if (r div 2 == 0) if (string_pos("gjapi_token", para) == 1) {
            t = string_copy(para, 13, string_length(para) - 12); r+= 2;
        }
        if (r == 3)
            break;
    }
    
    if (r == 3) {
        return (GJ_user_auth(argument0, u, t) == true);
    }
    
    return false;
}

#define GJ_user_auth
/*
**  Usage:
**      GJ_user_auth(map, username, token);
**
**  Arguments:
**      map             ds_map to save data to, data structure id
**      username        User's GJ log-In username (Not to be confused with developer name!), string
**      token           User's token, string
**
**  Returns:
**      success         boolean
**
**  Details:
**      Authenticates the user's information. If successful, it fills the given map with the user's details.
*/
{
    var newUrl, ret;
    newUrl = url_signature("users/auth/?username="+string(argument1)+"&user_token="+string(argument2), false);
    ret = netread(newUrl, 100000);
    
    if (string_pos('success:"false"', ret) == 1) {
        if (_GJ_SHOW_ERRORS == true)
            show_error(string_copy(ret, 27, string_length(ret) - 29), false); 
        return false;
    }
    if (GJ_user_fetch(argument0, argument1, 0) == true) {
        ds_map_add(argument0, "user_token", argument2);
        return true;
    }
    
    return false;
}

#define GJ_user_fetch
/*
**  Usage:
**      GJ_user_fetch(map, user detail, type);
**
**  Arguments:
**      map             ds_map to save data to, data structure id
**      user detail     the value to search for, string
**      type            0 if the user detail is a username / 1 if a user ID, real
**
**  Returns:
**      success         boolean
**
**  Details:
**      Fills given map with requested user's data.
**      To access the details loaded, use:
**          value = ds_map_find_value(map, "value name");
**
**      These are the value names that are loaded:
**    
**            - "id"              - "type"                - "username"
**            (ID of user)         (Gamer/Dev/Mod/Admin)
**        
**            - "avatar_url"      - "signed_up"           - "last_logged_in"
**        
**            - "status"
**             (Active/Banned)
**    
**      If the user is a developer, these extra values are also available:
**    
**            - "developer_name"  - "developer_website"   - "developer_description"
**
**      If the user is called through GJ_user_auth() or GJ_auto_login(), then this
**      value is available:
**
**            - "user_token"
**
*/
{
    var newUrl, ret;
    newUrl = url_signature("users/?" + (argument2 == true)*"user_id" + (argument2 == false)*"username" + "=" + string(argument1), false);
    ret = netread(newUrl, 100000000);
    
    if (string_pos('success:"false"', ret) == 1) {
        if (_GJ_SHOW_ERRORS == true)
            show_error(string_copy(ret, 27, string_length(ret) - 29), false);
        return false;
    }
    
    GJ_fill_map(argument0, ret);
    return true;
}

#define GJ_session_open
/*
**  Usage:
**      GJ_session_open(username, token);
**
**  Arguments:
**      username        User's GJ log-In username (Not to be confused with developer name!), string
**      token           User's token, string
**
**  Returns:
**      success         boolean
**
**  Details:
**      Opens a game session for a particular user. Allows you to tell Game Jolt that a user is playing
**      your game. You must ping the session to keep it active and you must close it when you're
**      done with it. Note that you can only have one open session at a time. If you try to open a
**      new session while one is running, the system will close out your current one before opening
**      a new one.
*/
{
    var newUrl, ret;
    newUrl = url_signature("sessions/open/?username="+string(argument0)+"&user_token="+string(argument1), false);
    ret = netread(newUrl, 100000);
    
    if (string_pos('success:"false"', ret) == 1) {
        if (_GJ_SHOW_ERRORS == true)
            show_error(string_copy(ret, 27, string_length(ret) - 29), false);
        return false;
    }
    
    return true;
}

#define GJ_session_ping
/*
**  Usage:
**      GJ_session_ping(username, token, idle?);
**
**  Arguments:
**      username        User's GJ log-In username (Not to be confused with developer name!), string
**      token           User's token, string
**      idle?           Whether user is idle in game or not, boolean
**
**  Returns:
**      success         boolean
**
**  Details:
**      Pings an open session to tell the system that it's still active. If the session hasn't been
**      pinged within 120 seconds, the system will close the session and you will have to open
**      another one. It's recommended that you ping every 30 seconds or so to keep the system
**      from cleaning up your session. You can also let the system know whether the player is in an
**      "active" or "idle" state within your game through this call.
*/
{
    var newUrl, ret;
    if (argument2 == true)
        argument2 = "&status=idle";
    else
        argument2 = "&status=active";
    
    newUrl = url_signature("sessions/ping/?username="+string(argument0)+"&user_token="+string(argument1)+argument2, false);
    ret = netread(newUrl, 100000);
    
    if (string_pos('success:"false"', ret) == 1) {
        if (_GJ_SHOW_ERRORS == true)
            show_error(string_copy(ret, 27, string_length(ret) - 29), false);
        return false;
    }
    
    return true;
}

#define GJ_session_close
/*
**  Usage:
**      GJ_session_close(username, token);
**
**  Arguments:
**      username        User's GJ log-In username (Not to be confused with developer name!), string
**      token           User's token, string
**
**  Returns:
**      success         boolean
**
**  Details:
**      Closes the active session.
*/
{
    var newUrl, ret;
    newUrl = url_signature("sessions/close/?username="+string(argument0)+"&user_token="+string(argument1), false);
    ret = netread(newUrl, 100000);
    
    if (string_pos('success:"false"', ret) == 1) {
        if (_GJ_SHOW_ERRORS == true)
            show_error(string_copy(ret, 27, string_length(ret) - 29), false);
        return false;
    }
    
    return true;
}

#define GJ_trophy_fetch
/*
**  Usage:
**      GJ_trophy_fetch(map, trophy id, username, token);
**
**  Arguments:
**      map             ds_map to save data to, data structure id
**      trophy id       The trophy ID to be loaded, real
**      username        User's GJ log-In username (Not to be confused with developer name!), string
**      token           User's token, string
**
**  Returns:
**      success         boolean
**
**  Details:
**      Fills the given map with the requested trophy's details.
**      To access the details loaded, use:
**          value = ds_map_find_value(map, "value name");
**
**      These are the value names that are loaded:
**    
**            - "id"              - "title"               - "description"
**            (ID of trophy)
**        
**            - "difficulty"      - "image_url"           - "achieved"
**            (Bronze/Silver/Gold/Platinum)               (false/time since achievement)
**
**
**      I reccommend keeping an offline record of your trophies for your convenience.
*/
{
    var newUrl, ret;
    newUrl = url_signature("trophies/?username="+string(argument2)+"&user_token="+string(argument3)+"&trophy_id="+string(argument1), false); 
    ret = netread(newUrl, 5000);
    
    if (string_pos('success:"false"', ret) == 1) {
        if (_GJ_SHOW_ERRORS == true)
            show_error(string_copy(ret, 27, string_length(ret) - 29), false);
        return false;
    }
    
    GJ_fill_map(argument0, ret);
    return true;
}

#define GJ_trophy_achieve
/*
**  Usage:
**      GJ_trophy_achieve(trophy_id, username, token);
**
**  Arguments:
**      trophy_id       ID of trophy to earn, real
**      username        User's GJ log-In username (Not to be confused with developer name!), string
**      token           User's token, string
**
**  Returns:
**      success         boolean
**
**  Details:
**      Sets a trophy as achieved for a particular user.
**      If you load and use GJ_trophy_fetch() to check whether or not your trophies are achieved instead
**      of keeping track of them offline, be sure to update the "achieved" value!
**
**          Example: ds_map_replace(trophy_map, "achieved", "true");
*/
{
    var newUrl, ret;
    newUrl = url_signature("trophies/add-achieved/?username="+string(argument1)+"&user_token="+string(argument2)+"&trophy_id="+string(argument0), false);
    ret = netread(newUrl, 100000);
    
    if (string_pos('success:"false"', ret) == 1) {
        if (_GJ_SHOW_ERRORS == true)
            show_error(string_copy(ret, 27, string_length(ret) - 29), false);
        return false;
    }
    
    return true;
}

#define GJ_highscore_table_fetch
/*
**  Usage:
**      GJ_highscore_table_fetch(list, table_id, limit, use user?[, username, user_token]);
**
**  Arguments:
**      list            ds_list to save scores in, data structure id
**      table_id        Table to load scores from (0 for primary), real
**      limit           Number of scores to load, real
**      use user?       Whether to load a user's specific scores, boolean
**    [ username        User's GJ log-In username (Not to be confused with developer name!), string
**      token           User's token, string ]
**
**  Returns:
**      success         boolean
**
**  Details:
**      Fills the given list with scores.
**      To access the details loaded, use:
**          value = ds_map_find_value(ds_list_find_value(list, place #), "value name");
**
**      These are the value names that are loaded:
**    
**            - "score"                 - "sort"                    - "extra_data"
**            (display score)           (value to sort by)          (any extra data the score may have)
**        
**            - "user"                  - "user_id"                 - "guest"
**            (user who scored)         (user id of who scored)     (if score was logged by guest, name of guest)
**
**            - "stored"
**            (if submitted user logged this score)
**
*/
{
    var newUrl, ret;
    newUrl = "scores/?limit="+string(median(1, argument2, 100));
    if (argument1 > 0)
        newUrl+= "&table_id="+string(argument1);
    if (argument3 == true)
        newUrl+= "&username="+string(argument4)+"&user_token="+string(argument5);
    
    newUrl = url_signature(newUrl, false); 
    ret = netread(newUrl, 10000);
    
    if (string_pos('success:"false"', ret) == 1) {
        if (_GJ_SHOW_ERRORS == true)
            show_error(string_copy(ret, 27, string_length(ret) - 29), false);
        return false;
    }
    
    GJ_fill_map_ext(argument0, ret);
    return true;
}

#define GJ_highscore_add
/*
**  Usage:
**      GJ_highscore_add(table_id, score, sort, extra_data, user?, name, token);
**
**  Arguments:
**      table_id        Table to add score to (0 for primary), real
**      score           Display score to submit, string
**      sort            Numerical value to sort by, real
**      extra_data      Any other data to embed to score (not shown anywhere on site!), string
**      user?           true for GJ user / false for guest, boolean
**      name            Name of scorer (must be username for user scores), string
**      token           User's token (only neccessary for user scores), string
**
**  Returns:
**      success         boolean
**
**  Details:
**      Adds a score for a user or guest.
*/
{
    var newUrl, ret;
    newUrl = "scores/add/?score="+string(argument1)+"&sort="+string(argument2)+"&extra_data="+argument3;
    if (argument0 > 0)
        newUrl+= "&table_id="+string(argument0);
    if (argument4 == true)
        newUrl+= "&username="+string(argument5)+"&user_token="+string(argument[6]);
    else
        newUrl+= "&guest="+string(argument5);
    
    newUrl = url_signature(newUrl, false);
    ret = netread(newUrl, 5000);
    
    if (string_pos('success:"false"', ret) == 1) {
        if (_GJ_SHOW_ERRORS == true)
            show_error(string_copy(ret, 27, string_length(ret) - 29), false);
        return false;
    }
    
    return true;
}

#define GJ_data_fetch
/*
**  Usage:
**      GJ_data_fetch(key, user data?[, username, token]);
**
**  Arguments:
**      key             Key of data to fetch, string
**      user data?      Whether to load from local user data or global data, boolean
**    [ username        User's GJ log-In username (Not to be confused with developer name!), string
**      token           User's token, string ]
**
**  Returns:
**      empty string    Upon failure
**      data            Upon success
**
**  Details:
**      Returns data from the Data Store.
*/
{
    var newUrl, ret;
    newUrl = "data-store/?format=dump&key="+string(argument0);
    if (argument1 == true)
        newUrl+= "&username="+string(argument[2])+"&user_token="+string(argument[3]);
    
    newUrl = url_signature(newUrl, false);
    ret = netread(newUrl, 100000);
    
    if (string_pos('FAILURE', ret) == 1) {
        if (_GJ_SHOW_ERRORS == true)
            show_error(string_copy(ret, 10, string_length(ret) - 9), false);
        return "";
    }
    return string_copy(ret, 10, string_length(ret) - 9);
}

#define GJ_data_fetch_keys
/*
**  Usage:
**      list = GJ_data_fetch(user data?[, username, token]);
**
**  Arguments:
**      user data?      Whether to load from local user data or global data, boolean
**    [ username        User's GJ log-In username (Not to be confused with developer name!), string
**      token           User's token, string ]
**
**  Returns:
**      noone           Upon failure
**      list            List filled with available keys upon success
**
**  Details:
**      Returns all the keys in either the game's global data store, or all the keys in a user's data
**      store.
*/
{
    var newUrl, ret, p, list; list = ds_list_create();
    newUrl = "data-store/get-keys/";
    if (argument0 == true)
        newUrl+= "?username="+string(argument[1])+"&user_token="+string(argument[2]);
    
    newUrl = url_signature(newUrl, argument0 == false);
    ret = netread(newUrl, 100000);
    
    if (string_pos('success:"false"', ret) == 1) {
        if (_GJ_SHOW_ERRORS == true)
            show_error(string_copy(ret, 10, string_length(ret) - 9), false);
        return "";
    }
    ret = string_delete(ret, 1, 21);
    p = string_pos(chr(13), ret);
    while (p > 0) {
        ds_list_add(list, string_copy(ret, 1, p - 2));
        ret = string_delete(ret, 1, p + 6);
        p = string_pos(chr(13), ret);
    }
}

#define GJ_data_set
/*
**  Usage:
**      GJ_data_set(key, data, user data?[, username, token]);
**
**  Arguments:
**      key             Key of data to set, string
**      data            Data to set, string
**      user data?      Whether to save to local user data or global data, boolean
**    [ username        User's GJ log-In username (Not to be confused with developer name!), string
**      token           User's token, string ]
**
**  Returns:
**      success         boolean
**
**  Details:
**      Sets data in the Data Store.
*/
{
    var newUrl, ret;
    newUrl = "data-store/set/?key="+string(argument0)+"&data="+string(argument1);
    if (argument2 == true)
        newUrl+= "&username="+string(argument[3])+"&user_token="+string(argument[4]);
    
    newUrl = url_signature(newUrl, false);
    ret = netread(newUrl, 100000);
    
    if (string_pos('success:"false"', ret) == 1) {
        if (_GJ_SHOW_ERRORS == true)
            show_error(string_copy(ret, 27, string_length(ret) - 29), false);
        return false;
    }
    return true;
}

#define GJ_data_remove
/*
**  Usage:
**      GJ_data_set(key, user data?[, username, token]);
**
**  Arguments:
**      key             Key of data to remove, string
**      user data?      Whether to save to local user data or global data, boolean
**    [ username        User's GJ log-In username (Not to be confused with developer name!), string
**      token           User's token, string ]
**
**  Returns:
**      success         boolean
**
**  Details:
**      Removes data from the Data Store.
*/
{
    var newUrl, ret;
    newUrl = "data-store/remove/?key="+string(argument0);
    if (argument1 == true)
        newUrl+= "&username="+string(argument[2])+"&user_token="+string(argument[3]);
    
    newUrl = url_signature(newUrl, false);
    ret = netread(newUrl, 5000);
    
    if (string_pos('success:"false"', ret) == 1) {
        if (_GJ_SHOW_ERRORS == true)
            show_error(string_copy(ret, 27, string_length(ret) - 29), false);
        return false;
    }
    return true;
}

#define GJ_data_update
/*
**  Usage:
**      GJ_data_update(key, operation, value, user data?[, username, token]);
**
**  Arguments:
**      key             Key of data to set, string
**      operation       add/subtract/multiply/divide for real values & append/prepend for string values, string
**      value           Value to work with, string/real
**      user data?      Whether to save to local user data or global data, boolean
**    [ username        User's GJ log-In username (Not to be confused with developer name!), string
**      token           User's token, string ]
**
**  Returns:
**      new value       Upon success
**      empty string    Upon failure
**
**  Details:
**      Updates data in the Data Store.
*/
{
    var newUrl, ret;
    newUrl = "data-store/update/?format=dump&key="+string(argument0)+"&value="+string(argument2)+"&operation="+string(argument1);
    if (argument3 == true)
        newUrl+= "&username="+string(argument[4])+"&user_token="+string(argument[5]);
    
    newUrl = url_signature(newUrl, false);
    ret = netread(newUrl, 100000);
    
    if (string_pos('FAILURE', ret) == 1) {
        if (_GJ_SHOW_ERRORS == true)
            show_error(string_copy(ret, 10, string_length(ret) - 9), false);
        return "";
    }
    return string_copy(ret, 10, string_length(ret) - 9);
}

